Index: trunk/SophyaProg/Tests/arrt.cc
===================================================================
--- trunk/SophyaProg/Tests/arrt.cc	(revision 2322)
+++ trunk/SophyaProg/Tests/arrt.cc	(revision 2578)
@@ -14,4 +14,6 @@
 static void tstmtx(int n);
 void _ZZ_TestTMatrixRC_YY_(TMatrix<r_8> & m);
+
+static int prtlev = 1;
 
 int main(int narg, char* arg[])
@@ -34,5 +36,4 @@
   int n = 5;
   if (narg > 2) n = atoi(arg[2]);
-  uint_4 prtlev = 1;
   uint_4 nprt = 50;
   if (narg > 3) prtlev = atoi(arg[3]);
@@ -75,31 +76,43 @@
   cout << "\n ::::::  Testing TMatrix - TVector ::::::  " << endl;  
   TMatrix<r_4> sma1 = ma(Range(1,2), Range(2,4));
-  cout << " ----- Matrix ma = \n " << ma << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix ma = \n " << ma << endl;
   sma1 = 3.14;
-  cout << " ----- Matrix ma (Avec sma1=ma(Range(1,2), Range(2,3))=3.14) = \n " << ma << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix ma (Avec sma1=ma(Range(1,2), Range(2,3))=3.14) = \n " << ma << endl;
   TMatrix<r_4> mb(2,3);
   mb = 50.;
   TMatrix<r_4> mc = mb+sma1;
-  cout << " ----- Matrix mc = mb(=50.)+sma1(=3.14) = " << mc << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix mc = mb(=50.)+sma1(=3.14) = " << mc << endl;
   TMatrix<r_4> md = (float)100+mc;
-  cout << " ----- Matrix md=100.+mc = " << md << endl;
-  cout << " ----- Matrix md-50 = " << md-(float)50. << endl;
+  if (prtlev > 0) {
+    cout << " ----- Matrix md=100.+mc = " << md << endl;
+    cout << " ----- Matrix md-50 = " << md-(float)50. << endl;
+  }
 
   TMatrix<int_4> ima(3,10);
   ima = RegularSequence(0.01,1.);
-  cout << " ----- Matrix ima(3,10) = RegularSequence(0.01,1.) = " << ima << endl;
-  cout << " ----- Matrix  ima.Column(3) = \n" << ima.Column(3) << endl;
+  if (prtlev > 0) {
+    cout << " ----- Matrix ima(3,10) = RegularSequence(0.01,1.) = " << ima << endl;
+    cout << " ----- Matrix  ima.Column(3) = \n" << ima.Column(3) << endl;
+  }
   TVector<int_4> vcol = ima.Column(7);
-  cout << " ----- Vector  vcol=ima.Column(7) = \n" << vcol << endl;
-  cout << " ----- Matrix  ima.Row(0) = \n" << ima.Row(0) << endl;
+  if (prtlev > 0) {
+    cout << " ----- Vector  vcol=ima.Column(7) = \n" << vcol << endl;
+    cout << " ----- Matrix  ima.Row(0) = \n" << ima.Row(0) << endl;
+  }
   TVector<int_4> vlig;
   vlig = ima.Row(1);
-  cout << " ----- Vector  vlig=ima.Row(1) = \n" << vlig << endl;
+  if (prtlev > 0) 
+    cout << " ----- Vector  vlig=ima.Row(1) = \n" << vlig << endl;
 
   TMatrix<int_4> imb(3,10);
   imb = RegularSequence(100.01,10.);
-  cout << " ----- Matrix imb(3,10) = RegularSequence(100.01,10.) = " << imb << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix imb(3,10) = RegularSequence(100.01,10.) = " << imb << endl;
   TMatrix<int_4> imc = ima+imb;
-  cout << " ----- Matrix imc=ima+imb = " << imc << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix imc=ima+imb = " << imc << endl;
   TMatrix<int_4> imd(3,10);
   TMatrix<int_4> imd2(3,10);
@@ -107,17 +120,22 @@
   imd *= 2;
   imd2 = 2;
-  imd.MulElt(imd2);
-  cout << " ----- Matrix imd (? = 100) " << imd << endl;
+  imd.MulElt(imd2,imd);
+  if (prtlev > 0) 
+    cout << " ----- Matrix imd (? = 100) " << imd << endl;
   imb -= imd;
   imc -= imd;
-  cout << " ----- Matrix ((imc-=imd)-(imb-=imd))-ima (== 0 ?) " 
-       << (imc-imb)-ima << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix ((imc-=imd)-(imb-=imd))-ima (== 0 ?) " 
+         << (imc-imb)-ima << endl;
   TVector<r_4> va(16, BaseArray::RowVector);
   va = RegularSequence(0.,1.);
-  cout << " ----- Vector va = RegularSequence(0.,1.) = " << va << endl;
+  if (prtlev > 0) 
+    cout << " ----- Vector va = RegularSequence(0.,1.) = " << va << endl;
   va(Range(2,0,6,2)) *= 10.;
-  cout << " ----- Vector va apres va(Range(2,0,6,2)) *= 10. " << va << endl;
+  if (prtlev > 0) 
+    cout << " ----- Vector va apres va(Range(2,0,6,2)) *= 10. " << va << endl;
   va(Range(0,5)) += 100.;
-  cout << " ----- Vector va apres va(Range(0,6)) += 100. " << va << endl;
+  if (prtlev > 0) 
+    cout << " ----- Vector va apres va(Range(0,6)) += 100. " << va << endl;
 
   TMatrix<r_4> esm(3,5);
@@ -128,6 +146,7 @@
          31 , 32 , 33, 34, 35  ;  
   esm = ess;
-  cout << "\n TMatrix<r_4> esm(3,5) = EnumeratedSequence(), 11 , 12 , 13, 14, 15 ... " 
-       << esm << endl;
+  if (prtlev > 0) 
+    cout << "\n TMatrix<r_4> esm(3,5) = EnumeratedSequence(), 11 , 12 , 13, 14, 15 ... " 
+         << esm << endl;
   r_4 emin,emax,esum,eprod,esumx2;
   esm.MinMax(emin, emax);  
@@ -136,6 +155,7 @@
   esumx2 = esm.SumX2();
 
-  cout << " Min= " << emin << "  Max= " << emax 
-       << " Sum= " << esum << " Prod=" << eprod << " SumX2=" << esumx2 << endl;
+  if (prtlev > 0) 
+    cout << " Min= " << emin << "  Max= " << emax 
+         << " Sum= " << esum << " Prod=" << eprod << " SumX2=" << esumx2 << endl;
 
   cout << "\n :::::: Testing Matrix operations :::::: " << endl;
@@ -150,15 +170,17 @@
   ra = es ;
   
-  cout << " ----- Matrix ra = \n " << ra << endl; 
-  cout << " ----- Matrix ira = \n " << ira << endl; 
-  cout << " ----- Matrix ira*ra = (= Identity ?) " << ira*ra << endl; 
-
+  if (prtlev > 0) {
+    cout << " ----- Matrix ra = \n " << ra << endl; 
+    cout << " ----- Matrix ira = \n " << ira << endl; 
+    cout << " ----- Matrix ira*ra = (= Identity ?) " << ira*ra << endl; 
+  }
 
   cout << "\n ::::::: Testing Matrix Inversion ::::::: " << endl;
   SimpleMatrixOperation<r_4> smr;
   TMatrix<r_4> cira = smr.Inverse(ra);
-  cout << " ----- Matrix Inverse(ra) =  " << cira << endl;
-  cout << " ----- ira-Inverse(ra) = " << ira-cira << endl;
-
+  if (prtlev > 0) {
+    cout << " ----- Matrix Inverse(ra) =  " << cira << endl;
+    cout << " ----- ira-Inverse(ra) = " << ira-cira << endl;
+  }
   Matrix a(n,n);
 
@@ -167,16 +189,21 @@
   //    for(int j=0; j<n; j++)  a(j,i) = GauRnd(0., 1.);
   a = RandomSequence(RandomSequence::Gaussian, 0., 2.5);
-  cout << " ----- Matrix a=RandomSequence(RandomSequence::Gaussian, 0., 2.5) = \n " << a << endl;
+  if (prtlev > 0) 
+    cout << " ----- Matrix a=RandomSequence(RandomSequence::Gaussian, 0., 2.5) = \n " << a << endl;
   Vector x(n);
   x = RegularSequence(1.,3.);
   Vector b = a*x;
-  cout << " ----- Vector x = \n " << x << endl;
-  cout << " ----- Vector b = a*x = \n " << b << endl;
+  if (prtlev > 0) {
+    cout << " ----- Vector x = \n " << x << endl;
+    cout << " ----- Vector b = a*x = \n " << b << endl;
+  }
   SimpleMatrixOperation<r_8> smo;
   Matrix inva = smo.Inverse(a);
-  cout << " ----- Matrix Inverse(a) = \n " << inva << endl;
-  cout << " ----- Matrix a*Inverse(a) = \n " << inva*a << endl;
-  cout << " ----- Matrix Inverse(a)*b (=Inv(a)*a*x) = \n " << inva*b << endl;
-  cout << " ----- Matrix x-Inverse(a)*b = (=0 ?)\n " << x-inva*b << endl;
+  if (prtlev > 0) {
+    cout << " ----- Matrix Inverse(a) = \n " << inva << endl;
+    cout << " ----- Matrix a*Inverse(a) = \n " << inva*a << endl;
+    cout << " ----- Matrix Inverse(a)*b (=Inv(a)*a*x) = \n " << inva*b << endl;
+    cout << " ----- Matrix x-Inverse(a)*b = (=0 ?)\n " << x-inva*b << endl;
+  }
 }
 